import java.util.*;
import java.io.*;

public class fence_ip_n2 {
    FastScanner in;
    PrintWriter out;
    final String TASK_NAME = "fence";

    public void solve() throws IOException {
        int n = in.nextInt();
        String s = in.next();
        if (n > 1000)
            throw new RuntimeException("n > 1000");
        List<Integer> a = new ArrayList<>(n);

        int mn = n + 1;
        for (int i = 0; i < s.length(); ++i) {
            int l = 0;
            while (i < s.length() &&  s.charAt(i) == '#') {
                ++i;
                ++l;
            }
            if (l != 0) {
                a.add(l);
                mn = Math.min(mn, l);
            }
        }
        mn %= n + 1;

        int[] ans = new int[n + 1];
        Arrays.fill(ans, -1);
        List<Integer>[] events = new ArrayList[n + 2];
        for (int i = 0; i <= n + 1; ++i)
            events[i] = new ArrayList<>();

        for (int k = 0; k < mn; ++k) {
            int l = 0, r = 0;
            for (Integer x : a) {
                r += x - k;
                l += (x + k) / (k + 1);
            }
            events[l].add(k + 1);
            events[r + 1].add(-k - 1);
        }
        TreeSet<Integer> tree = new TreeSet<>();
        for (int i = 1; i <= n; ++i) {
            for (Integer x : events[i])
                if (x > 0) tree.add(x - 1);
                else tree.remove(-x - 1);
            if (!tree.isEmpty())
                ans[i] = tree.first();
        }
        for (int i = 1; i <= n; ++i)
            if (i == n) out.println(ans[i]);
            else out.print(ans[i] + " ");
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new fence_ip_n2().run();
    }
}
